Index: uspace/drv/ohci/iface.c
===================================================================
--- uspace/drv/ohci/iface.c	(revision 31b568edfe51fae759acfc7b92d86748dfedeb6d)
+++ uspace/drv/ohci/iface.c	(revision b01995bc1785fe762503d71e2ecf19c3d7630acb)
@@ -33,11 +33,6 @@
  */
 #include <ddf/driver.h>
-#include <ddf/interrupt.h>
-#include <device/hw_res.h>
 #include <errno.h>
-#include <str_error.h>
-
-#include <usb_iface.h>
-#include <usb/ddfiface.h>
+
 #include <usb/debug.h>
 
@@ -60,10 +55,10 @@
 static int reserve_default_address(ddf_fun_t *fun, usb_speed_t speed)
 {
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_log_debug("Default address request with speed %d.\n", speed);
-  usb_device_keeper_reserve_default_address(&hc->manager, speed);
-  return EOK;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_log_debug("Default address request with speed %d.\n", speed);
+	usb_device_keeper_reserve_default_address(&hc->manager, speed);
+	return EOK;
 }
 /*----------------------------------------------------------------------------*/
@@ -75,10 +70,10 @@
 static int release_default_address(ddf_fun_t *fun)
 {
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_log_debug("Default address release.\n");
-  usb_device_keeper_release_default_address(&hc->manager);
-  return EOK;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_log_debug("Default address release.\n");
+	usb_device_keeper_release_default_address(&hc->manager);
+	return EOK;
 }
 /*----------------------------------------------------------------------------*/
@@ -90,18 +85,18 @@
  * @return Error code.
  */
-static int request_address(ddf_fun_t *fun, usb_speed_t speed,
-    usb_address_t *address)
-{
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  assert(address);
-
-  usb_log_debug("Address request with speed %d.\n", speed);
-  *address = device_keeper_get_free_address(&hc->manager, speed);
-  usb_log_debug("Address request with result: %d.\n", *address);
-  if (*address <= 0)
-    return *address;
-  return EOK;
+static int request_address(
+    ddf_fun_t *fun, usb_speed_t speed, usb_address_t *address)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	assert(address);
+
+	usb_log_debug("Address request with speed %d.\n", speed);
+	*address = device_keeper_get_free_address(&hc->manager, speed);
+	usb_log_debug("Address request with result: %d.\n", *address);
+	if (*address <= 0)
+		return *address;
+	return EOK;
 }
 /*----------------------------------------------------------------------------*/
@@ -113,13 +108,13 @@
  * @return Error code.
  */
-static int bind_address(ddf_fun_t *fun,
-    usb_address_t address, devman_handle_t handle)
-{
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_log_debug("Address bind %d-%d.\n", address, handle);
-  usb_device_keeper_bind(&hc->manager, address, handle);
-  return EOK;
+static int bind_address(
+    ddf_fun_t *fun, usb_address_t address, devman_handle_t handle)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_log_debug("Address bind %d-%d.\n", address, handle);
+	usb_device_keeper_bind(&hc->manager, address, handle);
+	return EOK;
 }
 /*----------------------------------------------------------------------------*/
@@ -132,12 +127,12 @@
 static int release_address(ddf_fun_t *fun, usb_address_t address)
 {
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_log_debug("Address release %d.\n", address);
-  usb_device_keeper_release(&hc->manager, address);
-  return EOK;
-}
-
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_log_debug("Address release %d.\n", address);
+	usb_device_keeper_release(&hc->manager, address);
+	return EOK;
+}
+/*----------------------------------------------------------------------------*/
 /** Register endpoint for bandwidth reservation.
  *
@@ -151,6 +146,6 @@
  * @return Error code.
  */
-static int register_endpoint(ddf_fun_t *fun,
-    usb_address_t address, usb_endpoint_t endpoint,
+static int register_endpoint(
+    ddf_fun_t *fun, usb_address_t address, usb_endpoint_t endpoint,
     usb_transfer_type_t transfer_type, usb_direction_t direction,
     size_t max_packet_size, unsigned int interval)
@@ -160,5 +155,5 @@
 	return ENOTSUP;
 }
-
+/*----------------------------------------------------------------------------*/
 /** Unregister endpoint (free some bandwidth reservation).
  *
@@ -169,5 +164,6 @@
  * @return Error code.
  */
-static int unregister_endpoint(ddf_fun_t *fun, usb_address_t address,
+static int unregister_endpoint(
+    ddf_fun_t *fun, usb_address_t address,
     usb_endpoint_t endpoint, usb_direction_t direction)
 {
@@ -194,27 +190,28 @@
  * @return Error code.
  */
-static int interrupt_out(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_out_callback_t callback, void *arg)
-{
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
-
-  usb_log_debug("Interrupt OUT %d:%d %zu(%zu).\n",
-      target.address, target.endpoint, size, max_packet_size);
-
-  usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_INTERRUPT,
-      max_packet_size, speed, data, size, NULL, 0, NULL, callback, arg,
-      &hc->manager);
-  if (!batch)
-    return ENOMEM;
-  batch_interrupt_out(batch);
-  const int ret = hc_schedule(hc, batch);
-  if (ret != EOK) {
-    batch_dispose(batch);
-    return ret;
-  }
-  return EOK;
+static int interrupt_out(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_out_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+
+	usb_log_debug("Interrupt OUT %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_INTERRUPT, max_packet_size,
+	        speed, data, size, NULL, 0, NULL, callback, arg, &hc->manager);
+	if (!batch)
+		return ENOMEM;
+	batch_interrupt_out(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -236,27 +233,27 @@
  * @return Error code.
  */
-static int interrupt_in(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_in_callback_t callback, void *arg)
-{
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
-  usb_log_debug("Interrupt IN %d:%d %zu(%zu).\n", 
-      target.address, target.endpoint, size, max_packet_size);
-
-  usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_INTERRUPT,
-      max_packet_size, speed, data, size, NULL, 0, callback, NULL, arg,
-      &hc->manager);
-  if (!batch)
-    return ENOMEM;
-  batch_interrupt_in(batch);
-  const int ret = hc_schedule(hc, batch);
-  if (ret != EOK) {
-    batch_dispose(batch);
-    return ret;
-  }
-  return EOK;
+static int interrupt_in(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_in_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+	usb_log_debug("Interrupt IN %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_INTERRUPT, max_packet_size,
+	        speed, data, size, NULL, 0, callback, NULL, arg, &hc->manager);
+	if (!batch)
+		return ENOMEM;
+	batch_interrupt_in(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -278,29 +275,28 @@
  * @return Error code.
  */
-static int bulk_out(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_out_callback_t callback, void *arg)
-{
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
-
-  usb_log_debug("Bulk OUT %d:%d %zu(%zu).\n",
-      target.address, target.endpoint, size, max_packet_size);
-
-  usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_BULK,
-      max_packet_size, speed, data, size, NULL, 0, NULL, callback, arg,
-      &hc->manager);
-  if (!batch)
-    return ENOMEM;
-  batch_bulk_out(batch);
-  const int ret = hc_schedule(hc, batch);
-  if (ret != EOK) {
-    batch_dispose(batch);
-    return ret;
-  }
-  return EOK;
-
+static int bulk_out(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_out_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+
+	usb_log_debug("Bulk OUT %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_BULK, max_packet_size, speed,
+	        data, size, NULL, 0, NULL, callback, arg, &hc->manager);
+	if (!batch)
+		return ENOMEM;
+	batch_bulk_out(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -322,27 +318,27 @@
  * @return Error code.
  */
-static int bulk_in(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_in_callback_t callback, void *arg)
-{
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
-  usb_log_debug("Bulk IN %d:%d %zu(%zu).\n",
-      target.address, target.endpoint, size, max_packet_size);
-
-  usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_BULK,
-      max_packet_size, speed, data, size, NULL, 0, callback, NULL, arg,
-      &hc->manager);
-  if (!batch)
-    return ENOMEM;
-  batch_bulk_in(batch);
-  const int ret = hc_schedule(hc, batch);
-  if (ret != EOK) {
-    batch_dispose(batch);
-    return ret;
-  }
-  return EOK;
+static int bulk_in(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_in_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+	usb_log_debug("Bulk IN %d:%d %zu(%zu).\n",
+	    target.address, target.endpoint, size, max_packet_size);
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_BULK, max_packet_size, speed,
+	        data, size, NULL, 0, callback, NULL, arg, &hc->manager);
+	if (!batch)
+		return ENOMEM;
+	batch_bulk_in(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -367,33 +363,33 @@
  * @return Error code.
  */
-static int control_write(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size,
-    void *setup_data, size_t setup_size,
-    void *data, size_t size,
+static int control_write(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size,
+    void *setup_data, size_t setup_size, void *data, size_t size,
     usbhc_iface_transfer_out_callback_t callback, void *arg)
 {
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
-  usb_log_debug("Control WRITE (%d) %d:%d %zu(%zu).\n",
-      speed, target.address, target.endpoint, size, max_packet_size);
-
-  if (setup_size != 8)
-    return EINVAL;
-
-  usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_CONTROL,
-      max_packet_size, speed, data, size, setup_data, setup_size,
-      NULL, callback, arg, &hc->manager);
-  if (!batch)
-    return ENOMEM;
-  usb_device_keeper_reset_if_need(&hc->manager, target, setup_data);
-  batch_control_write(batch);
-  const int ret = hc_schedule(hc, batch);
-  if (ret != EOK) {
-    batch_dispose(batch);
-    return ret;
-  }
-  return EOK;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+	usb_log_debug("Control WRITE (%d) %d:%d %zu(%zu).\n",
+	    speed, target.address, target.endpoint, size, max_packet_size);
+
+	if (setup_size != 8)
+		return EINVAL;
+
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_CONTROL, max_packet_size,
+	        speed, data, size, setup_data, setup_size, NULL, callback, arg,
+		&hc->manager);
+	if (!batch)
+		return ENOMEM;
+	usb_device_keeper_reset_if_need(&hc->manager, target, setup_data);
+	batch_control_write(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -418,29 +414,29 @@
  * @return Error code.
  */
-static int control_read(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size,
-    void *setup_data, size_t setup_size,
-    void *data, size_t size,
+static int control_read(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size,
+    void *setup_data, size_t setup_size, void *data, size_t size,
     usbhc_iface_transfer_in_callback_t callback, void *arg)
 {
-  assert(fun);
-  hc_t *hc = fun_to_hc(fun);
-  assert(hc);
-  usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
-
-  usb_log_debug("Control READ(%d) %d:%d %zu(%zu).\n",
-      speed, target.address, target.endpoint, size, max_packet_size);
-  usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_CONTROL,
-      max_packet_size, speed, data, size, setup_data, setup_size, callback,
-      NULL, arg, &hc->manager);
-  if (!batch)
-    return ENOMEM;
-  batch_control_read(batch);
-  const int ret = hc_schedule(hc, batch);
-  if (ret != EOK) {
-    batch_dispose(batch);
-    return ret;
-  }
-  return EOK;
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
+
+	usb_log_debug("Control READ(%d) %d:%d %zu(%zu).\n",
+	    speed, target.address, target.endpoint, size, max_packet_size);
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_CONTROL, max_packet_size,
+	        speed, data, size, setup_data, setup_size, callback, NULL, arg,
+		&hc->manager);
+	if (!batch)
+		return ENOMEM;
+	batch_control_read(batch);
+	const int ret = hc_schedule(hc, batch);
+	if (ret != EOK) {
+		batch_dispose(batch);
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -463,5 +459,5 @@
 
 	.control_write = control_write,
-	.control_read = control_read
+	.control_read = control_read,
 };
 
Index: uspace/drv/uhci-hcd/Makefile
===================================================================
--- uspace/drv/uhci-hcd/Makefile	(revision 31b568edfe51fae759acfc7b92d86748dfedeb6d)
+++ uspace/drv/uhci-hcd/Makefile	(revision b01995bc1785fe762503d71e2ecf19c3d7630acb)
@@ -37,7 +37,7 @@
 	transfer_list.c \
 	uhci.c \
-	uhci_hc.c \
-	uhci_rh.c \
-	uhci_struct/transfer_descriptor.c \
+	hc.c \
+	root_hub.c \
+	hw_struct/transfer_descriptor.c \
 	pci.c \
 	batch.c
Index: uspace/drv/uhci-hcd/batch.c
===================================================================
--- uspace/drv/uhci-hcd/batch.c	(revision 31b568edfe51fae759acfc7b92d86748dfedeb6d)
+++ uspace/drv/uhci-hcd/batch.c	(revision b01995bc1785fe762503d71e2ecf19c3d7630acb)
@@ -40,7 +40,6 @@
 #include "batch.h"
 #include "transfer_list.h"
-#include "uhci_hc.h"
+#include "hw_struct/transfer_descriptor.h"
 #include "utils/malloc32.h"
-#include "uhci_struct/transfer_descriptor.h"
 
 #define DEFAULT_ERROR_COUNT 3
Index: uspace/drv/uhci-hcd/batch.h
===================================================================
--- uspace/drv/uhci-hcd/batch.h	(revision 31b568edfe51fae759acfc7b92d86748dfedeb6d)
+++ uspace/drv/uhci-hcd/batch.h	(revision b01995bc1785fe762503d71e2ecf19c3d7630acb)
@@ -42,5 +42,5 @@
 #include <usb/host/batch.h>
 
-#include "uhci_struct/queue_head.h"
+#include "hw_struct/queue_head.h"
 
 usb_transfer_batch_t * batch_get(
